part of '../flutterx_live_data.dart';

abstract class SelfLiveData<T extends SelfLiveData<T>> extends ObservableData<T> with LiveObservableDataMixin<T> {
  final Set<LiveData> _sources = {};

  SelfLiveData() {
    super._setData(this as T);
  }

  void setFields(Iterable<LiveData> fields) {
    fields = {...fields};
    for (final source in [..._sources]) if (!fields.contains(source)) removeField(source);
    fields.forEach(addField);
  }

  void addField(LiveData field) => _sources.add(field) ? field.observeForever(__invalidate) : null;

  void removeField(LiveData field) => _sources.remove(field) ? field.removeObserver(__invalidate) : null;

  @override
  @nonVirtual
  void _setData(T value) => throw UnsupportedError('cannot set this instance');

  void __invalidate(dynamic _) => _invalidate();
}
