part of '../flutterx_live_data.dart';

mixin StateObserver<T extends StatefulWidget> on State<T>, ObserverMixin {
  @override
  void initState() {
    super.initState();
    doRegister();
  }

  @override
  void didUpdateWidget(T oldWidget) {
    super.didUpdateWidget(oldWidget);
    doRegister();
  }

  @override
  void dispose() {
    doUnregister();
    super.dispose();
  }
}
